// ============================================================================
// Created as a Drop in replacement for KillTrak.cs
// I basically took all the functions from KillTrak.cs, and replaced the code inside 'em :)
// ============================================================================// 
function KillTrak::Reset() 
{
  deleteVariables("KillTrak::*");
}

function KillTrak::DeathMessage(%msg, %weapon, %mod) 
{
  // Strip out the %1,%2,%3,%4, so we have a base message to compare to.
  %base = %msg;
  for (%i=1;%i<=4;%i++) // hope tribes can handle this loop >:)
    %base = String::Slice(%base,"%"@%i);

  $KillTrak::Weapon[%base] = %weapon;
  $KillTrak::Mod[%base] = %mod;

  // Check to see the format for this msg
  %pos["%1"] = String::FindSubStr(%msg,"%1");
  %pos["%2"] = String::FindSubStr(%msg,"%2");
  $KillTrak::KillerFirst[%base] = (%pos["%1"] < %pos["%2"]);
  $KillTrak::Single[%base] = (%pos["%1"] == -1);
  // echo("Added Kill Message: "@%msg@", Weapon: "@$KillTrak::Weapon[%base]@", Killer First: "@$KillTrak::KillerFirst[%base]@", BASE MSG: "@%base);
}

function KillTrak::GetKiller() {
	return $KillTrak::killer;
	}
function KillTrak::GetVictim() {
	return $KillTrak::victim;
	}
function KillTrak::GetWeapon() {
  return $KillTrak::weapon;
	}

function KillTrak::Parse(%client,%msg) {
  if (%client!=0) { return; }
  %names = 0;
  for (%i=1;%i<=$KillTrak::NumClients;%i++)
  {
    %name = Client::GetName($KillTrak::ClientList[%i]);
    if ((%pos = String::FindSubStr(%msg,%name))!=-1)
    {
      %names++;
      %name[%names] = %name;
      %pos[%names] = %pos;
    }
  }
  if (%names==0) { return; } // No names were found in this message
  %base = String::Slice(%msg,%name1);
  %base = String::Slice(%base,%name2);
  %base = String::Slice(%base,"his");
  %base = String::Slice(%base,"her");
  if ((%wpn=$KillTrak::Weapon[%base])=="") { return; }  // This is not a kill message
  else
  {
    if ($KillTrak::KillerFirst[%base] == (%pos1 < %pos2))
    {
      $KillTrak::Killer = getClientByName(%name1);
      $KillTrak::Victim = getClientByName(%name2);
    }
    else
    {
      $KillTrak::Killer = getClientByName(%name2);
      $KillTrak::Victim = getClientByName(%name1);
    }
    $KillTrak::Weapon = %wpn;
    if ($KillTrak::Single[%base]) { $KillTrak::Killer = $KillTrak::Victim; }
    if (Event::Returned(Event::Trigger(EventKillTrak,$KillTrak::Killer,$KillTrak::Victim,$KillTrak::Weapon),mute))
        return mute;
    return true;
  }
}

Event::Attach(EventClientMessage, KillTrak::Parse);
Event::Attach(EventClientJoin,KillTrak::ClientJoin);
Event::Attach(EventClientDrop,KillTrak::ClientDrop);
Event::Attach(EventChangeMission,KillTrak::ResetClients);
Event::Attach(EventConnected,KillTrak::ResetClients);

// ============================================================================
// Functions that I added.

function KillTrak::ClientJoin(%client)
{
  $KillTrak::NumClients++;
  $KillTrak::ClientList[$KillTrak::NumClients] = %client;
  $KillTrak::ClientIdx[%client] = $KillTrak::NumClients;
  echo("Added Client "@%client@" to KillTrak.");
}

function KillTrak::ClientDrop(%client)
{
  %lastClient = $KillTrak::ClientList[$KillTrak::NumClients];
  %thisIDX = $KillTrak::ClientIdx[%client];
  $KillTrak::ClientList[%thisIdx] = %lastClient;
  $KillTrak::ClientIdx[%lastClient] = %thisIdx;
  $KillTrak::ClientIdx[%client] = "";
  $KillTrak::ClientList[$KillTrak::NumClients] = "";
  $KillTrak::NumClients--;
  echo("Removed Client "@%client@" from KillTrak.");
}

function KillTrak::ResetClients()
{
   deleteVariables("KillTrak::Client*");
   $KillTrak::NumClients = 0;
   for (%cl=2100;%cl>2048;%cl--)
  {
    if (Client::GetName(%cl)!="")
      KillTrak::ClientJoin(%cl);
  }
}

// ============================================================================


// ============================================================================
// Support Functions
function String::Slice(%string,%substr)
{
	if ((%idx = String::FindSubStr(%string,%substr)) == -1)
		return %string;
	else
	{
		%left = String::GetSubStr(%string,0,%idx);
		%lensub = String::Len(%substr);
		%idxstart = %idx+%lensub;
		%right = String::GetSubStr(%string,%idxstart,1024);
		return %left @ %right;
	}
}

// Zear's, from MoreStrings.cs
function String::len(%string) {
    for(%length=0; String::getSubStr(%string, %length, 1) != ""; %length++) {} 
    return %length;
}
// ============================================================================

// ============================================================================
// For purely testing purposes
// 
//Event::Attach(EventKillTrak,Kill::Test);

function Kill::Test(%killer,%victim,%weapon)
{
  %kname = Client::GetName(%killer);
  %vname = Client::GetName(%victim);

  echo();
  echo(""@%kname@" killed "@%vname@" with a "@%weapon);
  echo();
//   remoteBP(2048,"<jc><F2>"@%kname@" <F0>killed <F2>"@%vname@" <F0>with a <F2>"@%weapon,3);
}
// 
// ============================================================================


// ============================================================================
// THE KILL MESSAGES!!!! The beauty of this system is that we don't need to separate these killmessages by mod!!!

// ============================================================================
// Base Kill Messages
KillTrak::DeathMessage("%2 falls to %3 death.", "Falling");
KillTrak::DeathMessage("%2 forgot to tie %3 bungie cord.", "Falling");
KillTrak::DeathMessage("%2 bites the dust in a forceful manner.", "Falling");
KillTrak::DeathMessage("%2 fall down go boom.", "Falling");

KillTrak::DeathMessage("%1 makes quite an impact on %2.", "Vehicle");
KillTrak::DeathMessage("%2 becomes the victim of a fly-by from %1.", "Vehicle");
KillTrak::DeathMessage("%2 leaves a nasty dent in %1's fender.", "Vehicle");
KillTrak::DeathMessage("%1 says, 'Hey %2, you scratched my paint job!'", "Vehicle");

KillTrak::DeathMessage("%1 ventilates %2 with %3 chaingun.", "Chaingun");
KillTrak::DeathMessage("%1 gives %2 an overdose of lead.", "Chaingun");
KillTrak::DeathMessage("%1 fills %2 full of holes.", "Chaingun");
KillTrak::DeathMessage("%1 guns down %2.", "Chaingun");

KillTrak::DeathMessage("%2 dies of turret trauma.", "Turret");
KillTrak::DeathMessage("%2 is chewed to pieces by a turret.", "Turret");
KillTrak::DeathMessage("%2 walks into a stream of turret fire.", "Turret");
KillTrak::DeathMessage("%2 ends up on the wrong side of a turret.", "Turret");
KillTrak::DeathMessage("%2 dies.", "Turret");


KillTrak::DeathMessage("%2 feels the warm glow of %1's plasma.", "Plasma");
KillTrak::DeathMessage("%1 gives %2 a white-hot plasma injection.", "Plasma");
KillTrak::DeathMessage("%1 asks %2, 'Got plasma?'", "Plasma");
KillTrak::DeathMessage("%1 gives %2 a plasma transfusion.", "Plasma");

KillTrak::DeathMessage("%2 catches a Frisbee of Death thrown by %1.", "Disc Launcher");
KillTrak::DeathMessage("%1 blasts %2 with a well-placed disc.", "Disc Launcher");
KillTrak::DeathMessage("%1's spinfusor caught %2 by surprise.", "Disc Launcher");
KillTrak::DeathMessage("%2 falls victim to %1's Stormhammer.", "Disc Launcher");

KillTrak::DeathMessage("%1 blows %2 up real good.", "Explosives");
KillTrak::DeathMessage("%2 gets a taste of %1's explosive temper.", "Explosives");
KillTrak::DeathMessage("%1 gives %2 a fatal concussion.", "Explosives");
KillTrak::DeathMessage("%2 never saw it coming from %1.", "Explosives");

KillTrak::DeathMessage("%1 adds %2 to %3 list of sniper victims.", "Laser Rifle");
KillTrak::DeathMessage("%1 fells %2 with a sniper shot.", "Laser Rifle");
KillTrak::DeathMessage("%2 becomes a victim of %1's laser rifle.", "Laser Rifle");
KillTrak::DeathMessage("%2 stayed in %1's crosshairs for too long.", "Laser Rifle");

KillTrak::DeathMessage("%1 mortars %2 into oblivion.", "Mortar");
KillTrak::DeathMessage("%2 didn't see that last mortar from %1.", "Mortar");
KillTrak::DeathMessage("%1 inflicts a mortal mortar wound on %2.", "Mortar");
KillTrak::DeathMessage("%1's mortar takes out %2.", "Mortar");

KillTrak::DeathMessage("%2 gets a blast out of %1.", "Blaster");
KillTrak::DeathMessage("%2 succumbs to %1's rain of blaster fire.", "Blaster");
KillTrak::DeathMessage("%1's puny blaster shows %2 a new world of pain.", "Blaster");
KillTrak::DeathMessage("%2 meets %1's master blaster.", "Blaster");

KillTrak::DeathMessage("%2 gets zapped with %1's ELF gun.", "ELF Gun");
KillTrak::DeathMessage("%1 gives %2 a nasty jolt.", "ELF Gun");
KillTrak::DeathMessage("%2 gets a real shock out of meeting %1.", "ELF Gun");
KillTrak::DeathMessage("%1 short-circuits %2's systems.", "ELF Gun");

KillTrak::DeathMessage("%2 didn't stay away from the moving parts.", "Crushed");
KillTrak::DeathMessage("%2 is crushed.", "Crushed");
KillTrak::DeathMessage("%2 gets smushed flat.", "Crushed");
KillTrak::DeathMessage("%2 gets caught in the machinery.", "Crushed");

KillTrak::DeathMessage("%2 is a victim among the wreckage.", "Debris");
KillTrak::DeathMessage("%2 is killed by debris.", "Debris");
KillTrak::DeathMessage("%2 becomes a victim of collateral damage.", "Debris");
KillTrak::DeathMessage("%2 got too close to the exploding stuff.", "Debris");

KillTrak::DeathMessage("%2 takes a missile up the keister.", "Missile");
KillTrak::DeathMessage("%2 gets shot down.", "Missile");
KillTrak::DeathMessage("%2 gets real friendly with a rocket.", "Missile");
KillTrak::DeathMessage("%2 feels the burn from a warhead.", "Missile");

KillTrak::DeathMessage("%2 ends it all.", "Suicide");
KillTrak::DeathMessage("%2 takes %3 own life.", "Suicide");
KillTrak::DeathMessage("%2 kills %3 own dumb self.", "Suicide");
KillTrak::DeathMessage("%2 decides to see what the afterlife is like.", "Suicide");
// ============================================================================